using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ElectronicPhoneBook.DataAccessLayer;

namespace ElectronicPhoneBook
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        DataLayer dl = new DataLayer();
        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
               MyGrid.DataSource = dl.LoadGrid();
               if (MyGrid.VisibleRowCount > 0)
               {
                   string strID = MyGrid[0, 0].ToString();
                   if (strID != string.Empty)
                   {
                       this.MyGrid.Select(0);
                       dl.SetValuetoBL(strID);
                       getValuefromBL();
                   }
                   button1.Enabled = true;
                   button2.Enabled = true;
                   btnSave.Enabled = false;
               }
               else
               {
                   ClearAll();
                   button1.Enabled = true;
                   button2.Enabled = false;
                   btnSave.Enabled = true;

               }
            }
            catch (Exception expMsg)
            {
               MessageBox.Show(expMsg.Message, "Electronic Phone Book");
            }
        }

        private void getValuefromBL()
        {
            txtFname.Text =     dl.FirstName;
            txtInitial.Text =   dl.MiddleInitial;
            txtLastName.Text =  dl.LastName;
            txtAdd1.Text =      dl.Address1;
            txtAdd2.Text =      dl.Address2;
            txtCity.Text =      dl.City;
            txtState.Text =     dl.State;
            txtZip.Text =       Convert.ToString(dl.ZipCode);
            txthomeph.Text =    dl.HomePhone;
            txtMobile.Text =    dl.MobilePhone;
            txtofficePh.Text =  dl.work;
            txtEmail.Text =     dl.EmailID;
            dtBirthday.Text =   dl.BirthDay;
        }

        
        private void MyGrid_MouseDown(object sender, MouseEventArgs e)
        {
            System.Windows.Forms.DataGrid.HitTestInfo hit = MyGrid.HitTest(e.X, e.Y);
            if (hit.Row >= 0)
            {
                this.MyGrid.Select(hit.Row);
                string strID = MyGrid[hit.Row,0].ToString();
                if (strID != string.Empty)
                {
                    dl.SetValuetoBL(strID);
                    getValuefromBL();
                    button1.Enabled = true;
                    button2.Enabled = true;
                    btnSave.Enabled = false;
                }
            }
        }

        private void ClearAll()
        {
            txtFname.Text = string.Empty;
            txtInitial.Text = string.Empty;
            txtLastName.Text = string.Empty;
            txtAdd1 .Text = string.Empty;
            txtAdd2.Text = string.Empty;
            txtCity.Text = string.Empty;
            txtState.Text = string.Empty;
            txtZip.Text = string.Empty;
            txthomeph.Text = string.Empty;
            txtMobile.Text = string.Empty;
            txtofficePh.Text = string.Empty;
            txtEmail.Text = string.Empty;
            dtBirthday.Text = string.Empty;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ClearAll();
            button1.Enabled = false;
            btnSave.Enabled = true;
            button2.Enabled = false;
            txtFname.Focus();
        }

        private bool Verification()
        {
            if (txtFname.Text == string.Empty)
            {
                txtFname.Focus();
                MessageBox.Show("Please Provide First Name");
                return false;
            }
            if (txtMobile.Text == string.Empty)
            {
                txtMobile.Focus();
                MessageBox.Show("Please Provide Mobile Number");
                return false;
            }
            return true;
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (Verification())
            {
                dl.FirstName = txtFname.Text;
                dl.MiddleInitial = txtInitial.Text;
                dl.LastName = txtLastName.Text;
                dl.Address1 = txtAdd1.Text;
                dl.Address2 = txtAdd2.Text;
                dl.City = txtCity.Text;
                dl.State = txtState.Text;
                dl.ZipCode = txtZip.Text;
                dl.HomePhone = txthomeph.Text;
                dl.MobilePhone = txtMobile.Text;
                dl.work = txtofficePh.Text;
                dl.EmailID = txtEmail.Text;
                dl.BirthDay = dtBirthday.Text;
                dl.SaveAll();
                this.Form1_Load(sender, e);
                btnSave.Enabled = false;
                button1.Enabled = true;
                button1.Enabled = true;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {

            if (MyGrid.CurrentRowIndex >= 0)
            {
                this.MyGrid.Select(MyGrid.CurrentRowIndex);
                string strID = MyGrid[MyGrid.CurrentRowIndex, 0].ToString();
                if (strID != string.Empty)
                {
                    dl.DeleteValue(strID);
                    this.Form1_Load(sender, e);
                }
            }

        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("http://cwithsharp.wordpress.com", "Veera");
        }
    }
}

